"""Preprocess."""

import menpo
from menpofit.fitter import align_shape_with_bounding_box
import numpy as np


class Preprocess(object):
  """Preprocess."""

  def __init__(self, params, image):
    self.params = params    
    
    if type(image) == np.ndarray:
      pixels = np.transpose(image, (2, 0, 1))
    else:
      pixels = image.pixels

    if np.max(pixels) > 1:
      pixels = pixels / 255.

    self.im = menpo.image.Image(pixels)


  def set_bbox(self, bbox):
    self.im.landmarks["bbox"] = bbox


  def get_pts_initial(self):
    self.im.landmarks["pts_initial"] = align_shape_with_bounding_box(
      self.params.reference_shape,
      self.im.landmarks["bbox"]
    )


  def crop(self):
    p = self.params.preprocess.image.crop
    self.im, t = self.im.crop_to_landmarks_proportion(p, group="bbox", return_transform=True)
    self.transform_crop = t


  def resize(self):
    shape = self.params.dataset.image.shape    
    n_channels = shape[-1]

    self.im, t = self.im.resize(shape[:-1], return_transform=True)
    self.transform_resize = t

    if n_channels == 1:
      try:
        self.im = self.im.as_greyscale()
      except:
        assert self.im.n_channels == 1

    elif n_channels == 3:
      if self.im.n_channels == 1:
        self.im.pixels = np.vstack([im.pixels] * 3)


  def tfslim_preprocess(self):
    self.im.pixels -= 0.5
    self.im.pixels *= 2.


REFERENCE = np.array(
  [
    [ 73.09741747,  41.97265311],
    [ 92.32815968,  42.52123696],
    [111.51403589,  44.88326231],
    [130.14206578,  49.08305398],
    [147.3267701 ,  56.63729775],
    [162.26541642,  68.14698187],
    [174.69162393,  82.12658084],
    [184.47892081,  97.59829872],
    [186.97655404, 114.95525553],
    [183.59493578, 131.97434174],
    [173.37990979, 146.93816365],
    [160.76815498, 160.53012021],
    [145.67998402, 171.54439035],
    [128.17092254, 178.70096839],
    [109.34685433, 182.34764158],
    [ 90.25838341, 184.06500687],
    [ 71.03998318, 184.3920242 ],
    [ 58.69607709,  54.42364322],
    [ 50.29703032,  63.37605758],
    [ 47.8785943 ,  75.99121882],
    [ 49.74673117,  89.06837929],
    [ 54.87415047, 100.93266075],
    [ 53.87677791, 123.3257525 ],
    [ 48.51422094, 135.78144869],
    [ 46.56030591, 148.76894011],
    [ 48.98198864, 161.35415385],
    [ 57.02041155, 170.13270378],
    [ 69.34623309, 112.74411442],
    [ 81.74783217, 112.89567816],
    [ 94.04903768, 113.08528663],
    [106.71703653, 113.33586406],
    [115.32911725,  98.41397488],
    [117.97296175, 105.71490331],
    [120.11106128, 113.30950526],
    [117.75130994, 120.90226869],
    [115.19103852, 127.6815167 ],
    [ 71.46205305,  69.03109519],
    [ 66.78332951,  76.83237067],
    [ 66.95205947,  86.1575748 ],
    [ 73.05964354,  94.16047575],
    [ 74.76328299,  85.8707979 ],
    [ 74.83568022,  76.53671958],
    [ 72.46304003, 130.80771207],
    [ 65.9183078 , 139.11136117],
    [ 65.83687026, 148.3374226 ],
    [ 70.26251433, 155.96340264],
    [ 73.63075063, 149.12845938],
    [ 73.97737924, 139.98522603],
    [138.73845632,  85.91325039],
    [134.26634261,  96.26944978],
    [132.06788518, 106.49289229],
    [133.83775878, 113.20672106],
    [131.94324767, 120.82017341],
    [134.08231069, 131.2463118 ],
    [137.79722359, 141.29555258],
    [147.99531784, 131.71323169],
    [152.56804597, 121.79472389],
    [153.54224959, 113.64555819],
    [152.87103042, 106.2070919 ],
    [148.66135267,  96.09985025],
    [139.17716694,  90.14888309],
    [138.26232703, 106.47539717],
    [138.9201452 , 113.31938246],
    [138.01432593, 121.00729446],
    [138.45087416, 137.06348029],
    [143.24441022, 121.189212  ],
    [144.30066033, 113.37828025],
    [143.56445265, 106.37596244]
  ]
)